javax.activation

## Class CommandMap

- java.lang.Object
- - javax.activation.CommandMap

- Direct Known Subclasses:
    MailcapCommandMap

      public abstract class CommandMap
      extends Object

  The CommandMap class provides an interface to a registry of command objects available in the system. Developers are expected to either use the CommandMap implementation included with this package (MailcapCommandMap) or develop their own. Note that some of the methods in this class are abstract.
  Since:
    1.6

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `CommandMap()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `abstract DataContentHandler` | `createDataContentHandler(String mimeType)` | Locate a DataContentHandler that corresponds to the MIME type.
    `DataContentHandler` | `createDataContentHandler(String mimeType, DataSource ds)` | Locate a DataContentHandler that corresponds to the MIME type.
    `abstract CommandInfo[]` | `getAllCommands(String mimeType)` | Get all the available commands for this type.
    `CommandInfo[]` | `getAllCommands(String mimeType, DataSource ds)` | Get all the available commands for this type.
    `abstract CommandInfo` | `getCommand(String mimeType, String cmdName)` | Get the default command corresponding to the MIME type.
    `CommandInfo` | `getCommand(String mimeType, String cmdName, DataSource ds)` | Get the default command corresponding to the MIME type.
    `static CommandMap` | `getDefaultCommandMap()` | Get the default CommandMap.
    `String[]` | `getMimeTypes()` | Get all the MIME types known to this command map.
    `abstract CommandInfo[]` | `getPreferredCommands(String mimeType)` | Get the preferred command list from a MIME Type.
    `CommandInfo[]` | `getPreferredCommands(String mimeType, DataSource ds)` | Get the preferred command list from a MIME Type.
    `static void` | `setDefaultCommandMap(CommandMap commandMap)` | Set the default CommandMap.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CommandMap

          public CommandMap()

  - ### Method Detail

    - #### getDefaultCommandMap

          public static CommandMap getDefaultCommandMap()

      Get the default CommandMap.

      - In cases where a CommandMap instance has been previously set to some value (via setDefaultCommandMap) return the CommandMap.
      - In cases where no CommandMap has been set, the CommandMap creates an instance of `MailcapCommandMap` and set that to the default, returning its value.
      Returns:
        the CommandMap

    - #### setDefaultCommandMap

          public static void setDefaultCommandMap(CommandMap commandMap)

      Set the default CommandMap. Reset the CommandMap to the default by calling this method with `null`.
      Parameters:
        `commandMap` - The new default CommandMap.
      Throws:
        `SecurityException` - if the caller doesn't have permission to change the default

    - #### getPreferredCommands

          public abstract CommandInfo[] getPreferredCommands(String mimeType)

      Get the preferred command list from a MIME Type. The actual semantics are determined by the implementation of the CommandMap.
      Parameters:
        `mimeType` - the MIME type
      Returns:
        the CommandInfo classes that represent the command Beans.

    - #### getPreferredCommands

          public CommandInfo[] getPreferredCommands(String mimeType,
                                                    DataSource ds)

      Get the preferred command list from a MIME Type. The actual semantics are determined by the implementation of the CommandMap.

      The `DataSource` provides extra information, such as the file name, that a CommandMap implementation may use to further refine the list of commands that are returned. The implementation in this class simply calls the `getPreferredCommands` method that ignores this argument.

      Parameters:
        `mimeType` - the MIME type
        `ds` - a DataSource for the data
      Returns:
        the CommandInfo classes that represent the command Beans.
      Since:
        JAF 1.1

    - #### getAllCommands

          public abstract CommandInfo[] getAllCommands(String mimeType)

      Get all the available commands for this type. This method should return all the possible commands for this MIME type.
      Parameters:
        `mimeType` - the MIME type
      Returns:
        the CommandInfo objects representing all the commands.

    - #### getAllCommands

          public CommandInfo[] getAllCommands(String mimeType,
                                              DataSource ds)

      Get all the available commands for this type. This method should return all the possible commands for this MIME type.

      The `DataSource` provides extra information, such as the file name, that a CommandMap implementation may use to further refine the list of commands that are returned. The implementation in this class simply calls the `getAllCommands` method that ignores this argument.

      Parameters:
        `mimeType` - the MIME type
        `ds` - a DataSource for the data
      Returns:
        the CommandInfo objects representing all the commands.
      Since:
        JAF 1.1

    - #### getCommand

          public abstract CommandInfo getCommand(String mimeType,
                                                 String cmdName)

      Get the default command corresponding to the MIME type.
      Parameters:
        `mimeType` - the MIME type
        `cmdName` - the command name
      Returns:
        the CommandInfo corresponding to the command.

    - #### getCommand

          public CommandInfo getCommand(String mimeType,
                                        String cmdName,
                                        DataSource ds)

      Get the default command corresponding to the MIME type.

      The `DataSource` provides extra information, such as the file name, that a CommandMap implementation may use to further refine the command that is chosen. The implementation in this class simply calls the `getCommand` method that ignores this argument.

      Parameters:
        `mimeType` - the MIME type
        `cmdName` - the command name
        `ds` - a DataSource for the data
      Returns:
        the CommandInfo corresponding to the command.
      Since:
        JAF 1.1

    - #### createDataContentHandler

          public abstract DataContentHandler createDataContentHandler(String mimeType)

      Locate a DataContentHandler that corresponds to the MIME type. The mechanism and semantics for determining this are determined by the implementation of the particular CommandMap.
      Parameters:
        `mimeType` - the MIME type
      Returns:
        the DataContentHandler for the MIME type

    - #### createDataContentHandler

          public DataContentHandler createDataContentHandler(String mimeType,
                                                             DataSource ds)

      Locate a DataContentHandler that corresponds to the MIME type. The mechanism and semantics for determining this are determined by the implementation of the particular CommandMap.

      The `DataSource` provides extra information, such as the file name, that a CommandMap implementation may use to further refine the choice of DataContentHandler. The implementation in this class simply calls the `createDataContentHandler` method that ignores this argument.

      Parameters:
        `mimeType` - the MIME type
        `ds` - a DataSource for the data
      Returns:
        the DataContentHandler for the MIME type
      Since:
        JAF 1.1

    - #### getMimeTypes

          public String[] getMimeTypes()

      Get all the MIME types known to this command map. If the command map doesn't support this operation, null is returned.
      Returns:
        array of MIME types as strings, or null if not supported
      Since:
        JAF 1.1

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.